Update ha_container.sh

This commit is contained in:
tteckster 2022-01-16 02:17:21 -05:00 committed by GitHub
parent e5699e079f
commit fe4e35e846
No known key found for this signature in database
GPG Key ID: 4AEE18F83AFDEB23
1 changed files with 11 additions and 29 deletions

View File

@ -8,14 +8,13 @@ while true; do
* ) echo "Please answer yes or no.";; * ) echo "Please answer yes or no.";;
esac esac
done done
set -o errexit
# Setup script environment set -o errtrace
set -o errexit #Exit immediately if a pipeline returns a non-zero status set -o nounset
set -o errtrace #Trap ERR from shell functions, command substitutions, and commands from subshell set -o pipefail
set -o nounset #Treat unset variables as an error
set -o pipefail #Pipe will exit with last non-zero status if applicable
shopt -s expand_aliases shopt -s expand_aliases
alias die='EXIT=$? LINE=$LINENO error_exit' alias die='EXIT=$? LINE=$LINENO error_exit'
CHECKMARK='\033[0;32m\xE2\x9C\x94\033[0m'
trap die ERR trap die ERR
trap cleanup EXIT trap cleanup EXIT
@ -73,13 +72,10 @@ function load_module() {
TEMP_DIR=$(mktemp -d) TEMP_DIR=$(mktemp -d)
pushd $TEMP_DIR >/dev/null pushd $TEMP_DIR >/dev/null
# Download setup script
wget -qL https://raw.githubusercontent.com/tteck/Proxmox/main/ha_setup.sh wget -qL https://raw.githubusercontent.com/tteck/Proxmox/main/ha_setup.sh
# Detect modules and automatically load at boot
load_module overlay load_module overlay
# Select storage location
while read -r line; do while read -r line; do
TAG=$(echo $line | awk '{print $1}') TAG=$(echo $line | awk '{print $1}')
TYPE=$(echo $line | awk '{printf "%-10s", $2}') TYPE=$(echo $line | awk '{printf "%-10s", $2}')
@ -105,15 +101,12 @@ else
done done
fi fi
info "Using '$STORAGE' for storage location." info "Using '$STORAGE' for storage location."
# Get the next guest VM/LXC ID
CTID=$(pvesh get /cluster/nextid) CTID=$(pvesh get /cluster/nextid)
info "Container ID is $CTID." info "Container ID is $CTID."
# Download latest Debian 10 LXC template echo -e "${CHECKMARK} \e[1;92m Updating LXC Template List... \e[0m"
msg "Updating LXC template list..."
pveam update >/dev/null pveam update >/dev/null
msg "Downloading LXC template..." echo -e "${CHECKMARK} \e[1;92m Downloading LXC Template... \e[0m"
OSTYPE=debian OSTYPE=debian
OSVERSION=${OSTYPE}-11 OSVERSION=${OSTYPE}-11
mapfile -t TEMPLATES < <(pveam available -section system | sed -n "s/.*\($OSVERSION.*\)/\1/p" | sort -t - -k 2 -V) mapfile -t TEMPLATES < <(pveam available -section system | sed -n "s/.*\($OSVERSION.*\)/\1/p" | sort -t - -k 2 -V)
@ -121,7 +114,6 @@ TEMPLATE="${TEMPLATES[-1]}"
pveam download local $TEMPLATE >/dev/null || pveam download local $TEMPLATE >/dev/null ||
die "A problem occured while downloading the LXC template." die "A problem occured while downloading the LXC template."
# Create variables for container disk
STORAGE_TYPE=$(pvesm status -storage $STORAGE | awk 'NR>1 {print $2}') STORAGE_TYPE=$(pvesm status -storage $STORAGE | awk 'NR>1 {print $2}')
case $STORAGE_TYPE in case $STORAGE_TYPE in
dir|nfs) dir|nfs)
@ -136,8 +128,7 @@ esac
DISK=${DISK_PREFIX:-vm}-${CTID}-disk-0${DISK_EXT-} DISK=${DISK_PREFIX:-vm}-${CTID}-disk-0${DISK_EXT-}
ROOTFS=${STORAGE}:${DISK_REF-}${DISK} ROOTFS=${STORAGE}:${DISK_REF-}${DISK}
# Create LXC echo -e "${CHECKMARK} \e[1;92m Creating LXC Container... \e[0m"
msg "Creating LXC container..."
DISK_SIZE=8G DISK_SIZE=8G
pvesm alloc $STORAGE $CTID $DISK $DISK_SIZE --format ${DISK_FORMAT:-raw} >/dev/null pvesm alloc $STORAGE $CTID $DISK $DISK_SIZE --format ${DISK_FORMAT:-raw} >/dev/null
if [ "$STORAGE_TYPE" == "zfspool" ]; then if [ "$STORAGE_TYPE" == "zfspool" ]; then
@ -152,35 +143,26 @@ pct create $CTID $TEMPLATE_STRING -arch $ARCH -features nesting=1 \
-hostname $HOSTNAME -net0 name=eth0,bridge=vmbr0,ip=dhcp -onboot 1 -cores 2 -memory 2048 \ -hostname $HOSTNAME -net0 name=eth0,bridge=vmbr0,ip=dhcp -onboot 1 -cores 2 -memory 2048 \
-ostype $OSTYPE -rootfs $ROOTFS,size=$DISK_SIZE -storage $STORAGE >/dev/null -ostype $OSTYPE -rootfs $ROOTFS,size=$DISK_SIZE -storage $STORAGE >/dev/null
# Modify LXC permissions to support Docker
LXC_CONFIG=/etc/pve/lxc/${CTID}.conf LXC_CONFIG=/etc/pve/lxc/${CTID}.conf
cat <<EOF >> $LXC_CONFIG cat <<EOF >> $LXC_CONFIG
lxc.cgroup2.devices.allow: a lxc.cgroup2.devices.allow: a
lxc.cap.drop: lxc.cap.drop:
EOF EOF
# Set container description
pct set $CTID -description "Access Portainer interface using the following URL.
http://<IP_ADDRESS>:9000"
# Set container timezone to match host
MOUNT=$(pct mount $CTID | cut -d"'" -f 2) MOUNT=$(pct mount $CTID | cut -d"'" -f 2)
ln -fs $(readlink /etc/localtime) ${MOUNT}/etc/localtime ln -fs $(readlink /etc/localtime) ${MOUNT}/etc/localtime
pct unmount $CTID && unset MOUNT pct unmount $CTID && unset MOUNT
# Setup container echo -e "${CHECKMARK} \e[1;92m Starting LXC Container... \e[0m"
msg "Starting LXC container..."
pct start $CTID pct start $CTID
pct push $CTID ha_setup.sh /ha_setup.sh -perms 755 pct push $CTID ha_setup.sh /ha_setup.sh -perms 755
pct exec $CTID /ha_setup.sh pct exec $CTID /ha_setup.sh
# Get network details and show completion message
IP=$(pct exec $CTID ip a s dev eth0 | sed -n '/inet / s/\// /p' | awk '{print $2}') IP=$(pct exec $CTID ip a s dev eth0 | sed -n '/inet / s/\// /p' | awk '{print $2}')
info "Successfully created Home Assistant Container LXC to $CTID." info "Successfully Created Home Assistant Container LXC to $CTID."
msg " msg "
Home Assistant is reachable by going to the following URLs. Home Assistant should be reachable by going to the following URL.
http://${IP}:8123 http://${IP}:8123
" "